// ConnectDlg.cpp : implementation file
//

#include "stdafx.h"
#include "demo3.h"
#include "ConnectDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CConnectDlg dialog


CConnectDlg::CConnectDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConnectDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConnectDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CConnectDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConnectDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConnectDlg, CDialog)
	//{{AFX_MSG_MAP(CConnectDlg)
	//}}AFX_MSG_MAP
	ON_MESSAGE(CLI_SOCK_CONNECT, OnConnect)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConnectDlg message handlers
BOOL CConnectDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	HICON hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	SetIcon(hIcon, TRUE);			// Set big icon
	SetIcon(hIcon, FALSE);		// Set small icon

	SetDlgItemText(IDC_EDIT1, "127.0.0.1");
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

LRESULT CConnectDlg::OnConnect(WPARAM wp, LPARAM lp)
{
	ASSERT( wp==(WPARAM)(&m_sock) );
	
	if ( 0==lp )
	{
		EndDialog(IDOK);
	}
	else
	{
		MessageBox("Connect failed", "connect", MB_OK|MB_ICONWARNING);
		EndDialog(IDCANCEL);
	}
	return 0L;
}

void CConnectDlg::OnOK() 
{
	// TODO: Add extra validation here
	CString addr;
	GetDlgItemText(IDC_EDIT1, addr);
	if ( addr.IsEmpty() )
	{
		MessageBox("Invalid server address", "connect", MB_OK|MB_ICONWARNING);
		return;
	}
	do
	{
		SetDlgItemText(IDC_STATIC_STATE, "Connecting...");

		if ( !m_sock.Create(0, SOCK_STREAM, FD_READ|FD_WRITE|FD_CONNECT|FD_CLOSE) )
			break;

		if ( m_sock.Connect(GetSafeHwnd(), addr, LISTEN_PORT) )
			return;
		
		if ( WSAEWOULDBLOCK==GetLastError() )
			return;
	}
	while(false);

	MessageBox("Cannot connect", "connect", MB_OK|MB_ICONWARNING);
	EndDialog(IDCANCEL);
//	CDialog::OnOK();
}



