//{{AFX_INCLUDES()
#include "mmbox.h"
//}}AFX_INCLUDES
#if !defined(AFX_SERVERDLG_H__8DFF671D_2281_44B5_B2BA_B8AC6B95E5BF__INCLUDED_)
#define AFX_SERVERDLG_H__8DFF671D_2281_44B5_B2BA_B8AC6B95E5BF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ServerDlg.h : header file
//

#include "ListenSocket.h"
#include "ServerTask.h"
#include "audcDlg.h"

/////////////////////////////////////////////////////////////////////////////
// CServerDlg dialog

class CServerDlg : public CDialog
{
	HICON m_hIcon;
	CListenSocket* m_listen;
	enum { MAX_TASKS=50 };
	CServerTask* m_tasks[MAX_TASKS];
	UINT m_clients;
	Packet* m_files_pack;
	CAudcDlg m_dlgAudc;
	CString m_audc;
	
public:
	bool m_bActive;

	void OnSocketAccept(CAsyncSocket& so, SOCKADDR& addr);
	void OnSocketClose(CServerTask* task);

	Packet* GetFilesPack()	{		return m_files_pack;	}
	Cmmbox& GetBox()	{	return m_mmb;	}
	LPCTSTR GetAudc()	{	return m_audc;	}
	UINT GetAudcKbps()	{	return m_dlgAudc.m_kbps;	}

// Construction
public:
	CServerDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CServerDlg)
	enum { IDD = IDD_SERVER_DIALOG };
	CListBox	m_files;
	Cmmbox	m_mmb;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CServerDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CServerDlg)
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	afx_msg void OnAdd();
	afx_msg void OnRemove();
	afx_msg void OnDestroy();
	afx_msg void OnAudc();
	//}}AFX_MSG
	afx_msg LRESULT OnAudcOutput(WPARAM wp, LPARAM lp);
	DECLARE_MESSAGE_MAP()

private:
	void OnStateChanged();
	void OnFilesChanged();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SERVERDLG_H__8DFF671D_2281_44B5_B2BA_B8AC6B95E5BF__INCLUDED_)
